package com.ekexiu.portal.service;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Delete;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.operate.Put;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.apt.web.annotation.param.RequestBody;
import org.jfw.util.StringUtil;

import com.ekexiu.portal.dao.ResourceDao;
import com.ekexiu.portal.po.Resource;

@Path("/resource")
public class ResourceService {
	@Autowrie
	private ResourceDao resourceDao;
	@Autowrie
	private ImageService imageService;

	public ResourceDao getResourceDao() {
		return resourceDao;
	}

	public void setResourceDao(ResourceDao resourceDao) {
		this.resourceDao = resourceDao;
	}

	public ImageService getImageService() {
		return imageService;
	}

	public void setImageService(ImageService imageService) {
		this.imageService = imageService;
	}

	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con, Resource resource,	@Nullable String professorId) throws SQLException, IOException {
		String resourceId = StringUtil.buildUUID();
		resource.setResourceId(resourceId);
		if (resource.getProfessorId() == null) {
			resource.setProfessorId(professorId);
		}
		this.resourceDao.insert(con, resource);
		this.imageService.saveDefaultResourcePhoto(resourceId);
		return resourceId;
	}

	@Put
	@Path
	public void update(@JdbcConn(true) Connection con, @RequestBody Resource resource, @Nullable String professorId) throws SQLException {
		if (resource.getProfessorId() != null)
			resource.setProfessorId(professorId);
		this.resourceDao.update(con, resource);
	}

	@Get
	@Path("/{resourceId}")
	public Resource query(@JdbcConn Connection con, @PathVar String resourceId) throws SQLException {
		return this.resourceDao.query(con, resourceId);
	}

	@Get
	@Path("/qa")
	public List<Resource> queryAll(@JdbcConn Connection con) throws SQLException {
		return this.resourceDao.query(con);
	}

	@Post
	@Path("/subject")
	public void updateSubject(@JdbcConn(true) Connection con, String resourceId, String subject) throws SQLException {
		this.resourceDao.updateSubject(con, resourceId, subject);
	}

	@Post
	@Path("/industry")
	public void updateIndustry(@JdbcConn(true) Connection con, String resourceId, String industry) throws SQLException {
		this.resourceDao.updateIndustry(con, resourceId, industry);
	}

	@Post
	@Path("/descp")
	public void updateDescp(@JdbcConn(true) Connection con, String resourceId, String descp) throws SQLException {
		this.resourceDao.updateDescp(con, resourceId, descp);
	}
	
	@Delete
	@Path("/{resourceId}")
	public void delete(@JdbcConn(true) Connection con,@PathVar String resourceId) throws SQLException {
		this.resourceDao.delete(con, resourceId);
	}
}
